#!/bin/bash
set -x
# this is script to post-post sea-ice data to make the observational nc file have the same length as the model output 
# for missing value, left null
# by CFUer huidu@ic3.cat
# ice_hadisst_N.nc, ice_nsidc_N.nc
#VAR=moc # heatc, ice

#VAR=$1
#SUFFIX=$2

DATA=$1
DATADIR=/cfu/scratch/huidu/ocean_obs

function locate_data(){
case $VAR in 
 'moc'|'heatc')
 DATADIR=/cfunas/diagnostics/postprocessed/${VAR}/nemovar/
 ;;

ice)

  case ${SOURCE} in 
   nsidc)
   DATADIR=/cfunas/diagnostics/postprocessed/${VAR}/nsidc
   ;;
   hadisst)
   DATADIR=/cfunas/diagnostics/postprocessed/${VAR}/ukmo
   ;;
  esac

;;

esac
} 

function create_wkdir(){

WORKDIR=/tmp/$USER/pick_obs/
mkdir -p ${WORKDIR}
cd ${WORKDIR}

}
#cat ${datalist}|while read line  ; do


#done


#cp /cfunas/diagnostics/postprocessed/${VAR}/${DATA} .
cp ${DATADIR}/${DATA} .

case $VAR in 
 moc)
 ncwa -O -a x $1 $1 2>/dev/null
 ;;
esac

output=`basename ${DATA} .nc`
output=${output}_new.nc
MISSING=-999.  


SYY=1960
SMM=11
SDATE=${SYY}-${SMM} #date with -  SDATE is model starting date
SDATE1=${SYY}${SMM} #date without -
EYY=2010
EMM=10
EDATE=${EYY}-${EMM} #date with -  EDATE is  model ending date
EDATE1=${EYY}${EMM} #date without -

function month_diff(){   
d1=$1 #YYYYMM 
yy1=${d1:0:4}
mm1=${d1:4:2}

if [[ ${mm1:0:1} -eq 0 ]]  # to get rid of 0 of 09 (month)
then 
mm1=${mm1:1:1}
fi

d2=$2 #YYYYMM
yy2=${d2:0:4} 
mm2=${d2:4:2}  #substract the string, get the month

if [[ ${mm2:0:1} -eq 0 ]]  # to get rid of 0 of 09 (month)
then
mm2=${mm2:1:1}
fi


ydiff=$((yy2-yy1))

if [[ $ydiff -eq 0 ]]

then
dmonth=$((mm2-mm1))
else 
dmonth=$((ydiff*12-mm1+mm2))
fi
}

month_diff 196011 201010

dmonth=$((dmonth+1))

cdo seldate,${SDATE},${EDATE} ${DATA} ${output} 

# to get the first year and month and the last year and month
nt=`cdo ntime ${output}`
echo $nt
iyear=`cdo showyear -seltimestep,1 ${output}`
imon=`cdo showmon -seltimestep,1 ${output}`
iyear=${iyear// /}
imon=${imon// /}

if [[ $imon -lt 10 ]] ; then
imon=0$imon
fi


eyear=`cdo  showyear -seltimestep,${nt} ${output}`
emon=`cdo showmon -seltimestep,${nt} ${output}`
eyear=${eyear// /}
emon=${emon// /}

if [[ $emon -lt 10 ]] ; then 
emon=0$emon
fi


echo ${iyear}-${imon} ${eyear}-${emon} 


cdo seltimestep,1 $DATA tmp1.nc 

#ncap2 -O -s 'sia()=-1.e+30;sie()=-1.e+30' tmp1.nc tmp1.nc
case $VAR in 
 ice)
 ncap2 -O -s "sia()=${MISSING};sie()=${MISSING}" tmp1.nc tmp1.nc
 ;;
 heatc)
 ncap2 -O -s "thc()=${MISSING};uhc()=${MISSING}" tmp1.nc tmp1.nc
 ;;
 moc)
 ncap2 -O -s "zomsfatl()=${MISSING}" tmp1.nc tmp1.nc
 ;;
esac

sdate_obs=${iyear}${imon}
edate_obs=${eyear}${emon}

if [[ ${SDATE1} -lt ${sdate_obs}  ]]

then
month_diff ${SDATE1} ${sdate_obs}
echo $dmonth "kaka"
cp tmp1.nc tmp.nc
for ((i=1;i<=$dmonth;i++)); do
 cdo cat tmp.nc ${output} toto.nc; mv toto.nc ${output}
done

fi

if [[ ${edate_obs} -lt ${EDATE1}  ]]
then

month_diff ${edate_obs} ${EDATE1}
cp tmp1.nc tmp.nc
for ((i=1;i<=$dmonth;i++)); do
 cdo cat ${output} tmp.nc toto.nc; mv toto.nc ${output}
done

fi

function change_fillvalue(){

ncatted -O -h -a _FillValue,$2,m,f,${MISSING} $1 > /dev/null
ncatted -O -h -a _Fillvalue,$2,m,f,${MISSING} $1 > /dev/null
ncatted -O -h -a missing_value,global,d,, $1 > /dev/null

}

case ${VAR} in 
 ice)
 change_fillvalue ${output} sia
 change_fillvalue ${output} sie
 ;;
 heatc)
 change_fillvalue ${output} thc
 change_fillvalue ${output} uhc
 ;;
 moc)
 change_fillvalue ${output} zomsfatl
 ;;
esac

rm tmp* ${DATA}



