#bin/bash
set -evx


#
# This script is to compute global mean values of SST from NEMOVAR.
#
# Written by Hui Du
#
# Created:   October 8, 2010
#



######### Begin of user modifications#########################

ferret='/opt/ferret/bin/ferret'
grid=grid_T
seasons="1101"  # 
mems=(0 1 2 3 4 )
var=sosstsst
yyint=5
save_dir="/cfu/scratch/$USER/sst/nemovar"
WORKDIR="/cfu/scratch/$USER/$$"
ferret='/opt/ferret/bin/ferret'
PATH_MASK="/cfu/pub/scripts/CDFTOOLS/constant_files"
script_dir="/cfu/pub/scripts/CDFTOOLS/scripts"
data_dir="/cfu/scratch/$USER/sst/nemovar"
ncl=/opt/ncl/bin/ncl
ncatted=/usr/local/bin/ncatted
ncrename=/usr/local/bin/ncrename
ifglobal=0  # If calculate global mean or regional, set it as 1 for global, otherwise, set it to 0

lonmin=-180
lonmax=180
latmin=-60
latmax=65
sec=3600
timeunit=hours
######### End of user modifications########################

export NCARG_ROOT=/opt/ncl  # Set NCARG environment for using NCL
export FER_GO=.
export FER_DATA=.

#
# Parameters
#
#
# Working directory
#


[[ -d $save_dir ]] || mkdir -p $save_dir


[[ -d $WORKDIR ]] || mkdir -p $WORKDIR

cd ${WORKDIR}



###
if [[ $latmin -lt 0 ]]; then
latname1=$((latmin*-1))S
elif [[ $latmin -eq 0 ]];then
latname1=$latmin
else [[ $latmin -gt 0 ]]
latname1=${latmin}N
fi


if [[ $latmax -lt 0 ]];then
latname2=$((latmax*-1))S
elif [[ $latmax -eq 0 ]];then
latname2=$latmax
else 
[[ $latmax -gt 0 ]]
latname2=${latmax}N
fi



if [[ $lonmin -lt 0 ]]; then
lonname1=$((lonmin*-1))W
elif [[ $lonmin -eq 0 ]];then
lonname1=$lonmin
else [[ $lonmin -gt 0 ]]
lonname1=${lonmin}E
fi


if [[ $lonmax -lt 0 ]];then
lonname2=$((lonmax*-1))W
elif [[ $lonmax -eq 0 ]];then
lonname2=$lonmax
else
[[ $lonmax -gt 0 ]]
lonname2=${lonmax}E
fi

if [[ $ifglobal -eq 1 ]]; then 
suffix=global
para=""
else
suffix=${lonname1}-${lonname2}_${latname1}-${latname2}
para="-sellonlatbox,$lonmin,$lonmax,$latmin,$latmax"
fi

#





############################################################################################3







for mem in ${mems[@]}; do # loop for numbers

OUTFILE=nemovar_sst_fc${mem}_$suffix.nc


file=nemovar_sst_fc${mem}.nc	
cp ${data_dir}/$file .        
cdo fldmean ${para} ${file} ${OUTFILE}
         
#cp ${script_dir}/addtime.sh .

#./addtime.sh date.txt ${OUTFILE} 

tvar=`ncdump -c $file|grep -i unlimited|cut -f1 -d"="`
tvar=${tvar// /}
echo $tvar
exit 1
${ncatted} -h -a units,${tvar},c,c,"${timeunit} since ${sdate} 00:00:00" ${fnc}

#mv ${OUTFILE} ${save_dir}/$OUTFILE


done # loop for members


cd

#rm -rf $WORKDIR

