#!/bin/bash

export FER_GO=.
export FER_DATA=.

SCRIPTDIR=/cfu/pub/scripts/PI
OBSDIR=/cfu/pub/scripts/PI/Climate_obs_data
#RUNDIR=/cfu/scratch/huidu/temp
RUNDIR=/var/tmp
ferret='/opt/ferret/bin/ferret'
#cd $RUNDIR
script_file="ferret_script.jnl"

cp ${SCRIPTDIR}/orca_interp.jnl .
cp ${OBSDIR}/OPAT_to_2x2.nc .

cat >${script_file} <<-EOF
go orca_interp.jnl ORCA1_MM_ALL_grid_T.nc
let/unit="Celsius"/title="NEMO Sea Surface Temperature" SST_2=sosstsst1[k=1]
let/unit="PSU"/title="NEMO Sea Surface Salinity" SSS_2=sosaline1[k=1]
let/unit="1"/title="NEMO Sea Ice Cover" SICE_2=soicecov1[k=1]
set memory/size=2000
save/file="SST_mon_2x2.nc"/clobber SST_2
save/file="SSS_mon_2x2.nc"/clobber SSS_2
save/file="SICE_mon_2x2.nc"/clobber SICE_2
EOF
echo "go ${script_file}; quit" | ${ferret} -nojnl -gif
rm -f ${script_file}



exit 0
