#!/bin/bash
set -exv

### General Settings ###
########################

BASIN=MyBASIN
LATMIN=MyLATMIN
LATMAX=MyLATMAX
DEPMIN=MyDEPMIN
DEPMAX=MyDEPMAX

BASIN=MyBASIN
LATMIN=MyLATMIN
LATMAX=MyLATMAX
DEPMIN=MyDEPMIN
DEPMAX=MyDEPMAX

GRID=grid_V
EXPID=$1  # experiment ID
SDATE=$2
MEMBER_LST=( MyMEM )
MEMBER_LST=( 0 1 2 3 4 )
MEMBER_LST=( 1 )
#SDATE_LST=( MySDATE )
SAVEDIR="/cfunas/diagnostics/postprocessed/moc/${EXPID}"
DATADIR=MyDIR
#DATADIR=
DATA=MyDATA  #obs/model
DATA=model  #obs/model
WORKDIR="/tmp/moc/${EXPID}"
MASK_FILE=ecearth_mm_lsm.nc
PATH_MASK="/home/vguemas/analysis_hui/constant_files"
SCRIPTDIR="/home/vguemas/analysis_hui"

######### End of user modifications########################

CDFTOOLS=/home/huidu/scripts/analysis/lib
CON_FILES=/home/huidu/scripts/analysis/constant_files
#PATH=${PATH}:/share/apps/cdftools-2.1/intel11/bin:/share/apps/cdo-1.4.5.1/intel11/bin/:/share/apps/nco-3.9.9/intel11/bin/:/share/apps/ferret/bin/:/share/apps/netcdf-3.6.0-p1/intel10/bin/
mkdir -p ${SAVEDIR}
rm -rf ${WORKDIR}; mkdir -p ${WORKDIR}
cd ${WORKDIR}


	para2="$BASIN $LATMIN $LATMAX $DEPMIN $DEPMAX "
        prefix2=maxmoc
	suffix2=${DEPMIN}-${DEPMAX}_$BASIN
	
	### Actual Computation ###
case ${DATA} in 
model)
DATADIR=/cfunas/exp/ecearth/${EXPID}/${SDATE}/
##########################
for mem in  ${MEMBER_LST[@]}; do
  echo "******************** Start $mem **********************"
  merged=moc_fc$mem
  output1=moc_${EXPID}_${SDATE}_fc${mem}
  output2=${prefix2}_${EXPID}_${SDATE}_fc${mem}_${suffix2}
  ln -sf $CON_FILES/mask.nc .
  ln -sf $CON_FILES/mesh_hgr.nc .
  ln -sf $CON_FILES/mesh_zgr.nc .
  ln -sf $CON_FILES/new_maskglo.nc .

 # yr=`echo ${SDATE}|cut -c1-4`
  source_dir=${DATADIR}/fc${mem}/outputs
  files=`find ${source_dir} -name MMO*${EXPID}_${SDATE}_fc${mem}_*.tar`
  for file in $files; do
    file1=`tar tf $file | grep ${GRID}`
    tar xvf $file ${file1}
    gunzip ${file1}
    file2=`basename $file1 .gz`  # not a good way, need better solution 
    /bin/rm -f ${file2}.tmp
    ncks -v vomecrty,nav_lon,nav_lat,depthv,time_counter ${file2} -o ${file2}.tmp;rm ${file2};mv ${file2}.tmp ${file2}
    done
    merged=${EXPID}_${SDATE}_fc${mem}_ORCA1
    /bin/rm -f ${merged}
    cdo mergetime ORCA1_MM_*_${GRID}.nc ${merged}.nc
    chmod 777 ${EXPID}*.nc



    output1=moc_${EXPID}_${SDATE}_fc${mem}


    for t in $(seq 1 1 `cdo ntime ${merged}.nc`); do
     cdo seltimestep,$t ${merged}.nc tmp.nc
     /home/vguemas/analysis_hui/lib/cdfmoc tmp.nc 
     cdo cat moc.nc ${output1}.nc
   #  /home/vguemas/analysis_hui/lib/cdfmaxmoc moc.nc $para2
   #  cdo cat maxmoc.nc ${output2}.nc
     rm -f maxmoc.nc tmp.nc moc.nc 
    done

    unit=`ncdump -c ${merged}.nc | grep "time:units" | cut -d '"' -f2`
    #change attribute and unit name
 #   ncatted -h -a units,time,m,c,"$unit" ${output2}.nc
 #   ncatted -h -a time,time,d,, ${output2}.nc
	 

    ncks -h -v time ${merged}.nc -o time.nc
    ncks -h -A time.nc ${output1}.nc
 #   ncks -h -A time.nc ${output2}.nc
    rm -f time.nc

    mv ${output1}.nc ${SAVEDIR}; rm ORCA*
  #  mv ${output2}.nc ${SAVEDIR}
    echo "******************** END $mem  *********************"
  done  #loop for memeber 

;;

obs)   # case conditions for model or observation

cd ${WORKDIR}

ln -sf $CON_FILES/mask.nc .
ln -sf $CON_FILES/mesh_hgr.nc .
ln -sf $CON_FILES/mesh_zgr.nc .
ln -sf $CON_FILES/new_maskglo.nc .

DATADIR=/share/data/cfu/data/ecmwf/${EXPID}
cp ${CON_FILES}/nemovar_time.nc ./time.nc
cp ${CDFTOOLS}/cdfmoc .
cp ${CDFTOOLS}/cdfmaxmoc .
pwd

for mem in ${MEMBER_LST}; do # loop for mems
 echo "******************** $mem *********************"
 echo

 output1=moc_opa${mem}_${DEPMIN}-${DEPMAX}.nc
 output2=maxmoc_opa${mem}_${DEPMIN}-${DEPMAX}_${BASIN}.nc
 files=`ls ${DATADIR}/opa${mem}/*${GRID}*.gz`
 for f in ${files}; do #loop for gz files
  cp ${f} ./moc_tmp.nc.gz
  gunzip moc_tmp.nc.gz
  ./cdfmoc moc_tmp.nc
  ./cdfmaxmoc moc.nc $para2
  cdo cat moc.nc ${output1}
  cdo cat maxmoc.nc ${output2}
  rm moc.nc maxmoc.nc moc_tmp.nc

 done #loop for nc files

 ncks -A time.nc ${output1}
 ncks -A time.nc ${output2}


 mv ${output1} ${SAVEDIR}
 mv ${output2} ${SAVEDIR}

done # loop for mems
;;


esac

rm -r ${WORKDIR}

