#/bin/bash
set -evx

listpost=( 'sia' 'ohc' 'moc' 'max_moc' 'max_moc2' 'area_moc' 'ice' 'sstsimld' 'heat_sal_mxl' 'psi_U')
# Possible options : ( 'sia' 'ohc' 'moc' 'max_moc' 'max_moc2' 'area_moc' 'ice' 'sstsimld' 'heat_sal_mxl' 'psi_U' )
listmemb=( 0 )
expid=b03e
year0=1992
yearf=1994
chunklen=6
WORKDIR=/scratch/tmp/post_hector/$$
yeari=1990
nemovers=v3.2
mkdir -p $WORKDIR
cd $WORKDIR
for memb in ${listmemb[@]} ; do
  for ((year=${year0};year<=${yearf};year++));do
  
    case $chunklen in
      12) 
        cp /cfunas/exp/nemo/${expid}/${yeari}0101/fc${memb}/outputs/diags_${expid}_${yeari}0101_fc${memb}_${year}0101-${year}1231.tar .
        tar -xf diags_${expid}_${yeari}0101_fc${memb}_${year}0101-${year}1231.tar 
        ;;
      6)
        cp /cfunas/exp/nemo/${expid}/${yeari}0101/fc${memb}/outputs/diags_${expid}_${yeari}0101_fc${memb}_${year}0101-${year}0630.tar .
        cp /cfunas/exp/nemo/${expid}/${yeari}0101/fc${memb}/outputs/diags_${expid}_${yeari}0101_fc${memb}_${year}0701-${year}1231.tar .
        tar -xf diags_${expid}_${yeari}0101_fc${memb}_${year}0101-${year}0630.tar   
        tar -xf diags_${expid}_${yeari}0101_fc${memb}_${year}0701-${year}1231.tar
        listroots="heat_sal_mxl ice moc psi_U psi_V sal_0-300m sal_300-5400m sstsimld t3d"
        for filebase in $listroots ; do
          ncrcat -O ${filebase}_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}0630.nc ${filebase}_${expid}_fc${memb}_${yeari}0101_${year}0701_${year}1231.nc ${filebase}_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
          rm -f ${filebase}_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}0630.nc ${filebase}_${expid}_fc${memb}_${yeari}0101_${year}0701_${year}1231.nc
        done
      ;;
    esac
  
    for post in ${listpost[@]} ; do
       
      case $post in

        'max_moc')

ncra -O moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
cdfmaxmoc tmp.nc atl 38 50 500 2000
cdo cat maxmoc.nc max_moc_38N50N_500m-2km_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
rm -f maxmoc.nc tmp.nc
        ;;

        'max_moc2')

ncra -O moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
cdfmaxmoc tmp.nc atl 40 40 0 6000
cdo cat maxmoc.nc max_moc_40N_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
rm -f maxmoc.nc tmp.nc 
        ;;

        'area_moc')
ncrename -d y,lat -v nav_lat,lat moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
  ncks -O -v zomsfatl,time,time_bnds moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
  ncks -O -v zomsfatl,time moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
fi
ncdump tmp.nc > tmp.cdl
sed -e "s/lat(lat, x)/lat(lat)/g" tmp.cdl > tmp2.cdl
sed -e "s/zomsfatl(time_counter, depthw, lat, x)/zomsfatl(time_counter, depthw, lat)/g" tmp2.cdl > tmp.cdl
ncgen -o tmp.nc tmp.cdl
ncks -d lat,40.,55. -d depthw,-2000.,-1000. tmp.nc area_moc.nc
cdo vertmean area_moc.nc area_ave_moc.nc
ncap -O -s "coslat[lat]=cos(lat[lat]*3.141592657/180.0)" area_ave_moc.nc area_ave_moc2.nc
ncwa -w coslat -a lat area_ave_moc2.nc area_ave_moc3.nc
ncks -O -v zomsfatl,time area_ave_moc3.nc area_ave_moc3.nc
cdo cat area_ave_moc3.nc moc_40N55N_1-2km_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
rm -f tmp.nc area_moc.nc area_ave_moc.nc tmp.cdl tmp2.cdl area_ave_moc2.nc area_ave_moc3.nc
        ;;
         
        'moc' )
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
fi
cdo cat moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
        ;;

        'sia' )
cp /home/vguemas/tools/ice_template.nc toto_N.nc
cp /home/vguemas/tools/ice_template.nc toto_S.nc
cp /home/vguemas/tools/mesh_mask_nemo.$nemovers.nc  mesh_hgr.nc
cp /home/vguemas/tools/mesh_mask_nemo.$nemovers.nc  mask.nc 
for ((jt=1;jt<=12;jt++)) ; do
  rm -f tmp.nc ice.txt
  ncks -d time,$((jt-1)) ice_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
  cdficediags tmp.nc>ice.txt
  for d in N S;do
    ncdump toto_${d}.nc  > ice_template.cdl
    sia=`grep ${d}Area ice.txt |awk '{print $4}'`
    sie=`grep ${d}Extend ice.txt|awk '{print $4}'`
    siv=`grep ${d}Volume ice.txt|awk '{print $4}'`
    sed -e "s/sia =.*/sia = $sia ;/" ice_template.cdl > ice_template2.cdl
    sed -e "s/sie =.*/sie = $sie ;/" ice_template2.cdl > ice_template3.cdl
    sed -e "s/siv =.*/siv = $siv ;/" ice_template3.cdl > ice_template.cdl
    ncgen -o ice.nc ice_template.cdl
    if [ `echo $expid | cut -c1` == 'h' ] ; then
      ncks -A -v time,time_bnds tmp.nc ice.nc
    else
      ncks -A -v time tmp.nc ice.nc
    fi
    cdo cat ice.nc sia_${d}_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc   
  done  #loop for N and S
done # loop for time
rm -f tmp.nc ice.txt ice.nc ice_template.cdl ice_template2.cdl ice_template3.cdl
        ;;
 
        'ice' )
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc ice_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc ice_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
fi
cdo cat ice_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc ice_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
        ;;

        'ohc')
cp /home/vguemas/tools/heatc_template.nc template_heatc.nc
cp /home/vguemas/tools/mesh_mask_nemo.$nemovers.nc  mesh_hgr.nc 
cp /home/vguemas/tools/mesh_mask_nemo.$nemovers.nc  mesh_zgr.nc
cp /home/vguemas/tools/mesh_mask_nemo.$nemovers.nc  mask.nc
ncdump template_heatc.nc > template_heatc.cdl
for ((jt=1;jt<=12;jt++)) ; do
 rm -f tmp.nc
 ncks -d time,$((jt-1)) t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc tmp.nc
 cdfheatc tmp.nc $para > tmp.log
 thc=`cat tmp.log | grep "Total Heat content :" | awk '{print $5}'`;
 uhc=`cat tmp.log | grep "Total Heat content/volume" | awk '{print $5}'`;
 sed -e "s/thc =.*/thc = $thc ;/" template_heatc.cdl > template_heatc2.cdl
 sed -e "s/uhc =.*/uhc = $uhc ;/" template_heatc2.cdl > template_heatc.cdl
 ncgen -o heatc.nc template_heatc.cdl
 if [ `echo $expid | cut -c1` == 'h' ] ; then
   ncks -A -v time,time_bnds tmp.nc heatc.nc
 else
 ncks -A -v time tmp.nc heatc.nc
 fi
 cdo cat heatc.nc heatc_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
done
rm -f template_heatc.cdl template_heatc2.cdl template_heatc.nc heatc.nc tmp.nc
        ;;
 
        'sstsimld')
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sstsimld_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sstsimld_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
fi
cdo cat sstsimld_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sstsimld_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
        ;;
        
        'heat_sal_mxl')
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc heat_sal_mxl_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc heat_sal_mxl_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
fi
cdo cat heat_sal_mxl_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc heat_sal_mxl_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
        ;;

        'psi_U')
if [ `echo $expid | cut -c1` == 'h' ] ; then
  ncks -A -v time,time_bnds t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc psi_U_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
else
  ncks -A -v time t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc psi_U_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
fi
cdo cat psi_U_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc psi_U_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc
      esac

    done

    rm -f diags_${expid}_${yeari}0101_fc${memb}_${year}0101-${year}1231.tar psi_U_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc psi_V_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc heat_sal_mxl_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sal_0-300m_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sal_300-5400m_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc ice_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc moc_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc sstsimld_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc t3d_${expid}_fc${memb}_${yeari}0101_${year}0101_${year}1231.nc
  done

  for post in ${listpost[@]} ; do
    pathout=/scratch/hector/$post/$expid
    mkdir -p $pathout
    case $post in
      'area_moc') files=('moc_40N55N_1-2km');;
      'max_moc') files=('max_moc_38N50N_500m-2km');;
      'max_moc2') files=('max_moc_40N');;
      'sia' ) files=('sia_N' 'sia_S') ;;
      'moc') files=('moc') ;;
      'ice') files=('ice') ;;
      'sstsimld') files=('sstsimld') ;;
      'heat_sal_mxl') files=('heat_sal_mxl') ;;
      'psi_U') files=('psi_U') ;;
      'ohc') files=('heatc') ;;
    esac
    for file in ${files[@]} ; do
      if [ -e ${pathout}/${file}_${expid}_fc${memb}_${yeari}0101_${yeari}0101_$((year0-1))1231.nc ] ; then
        ncrcat ${pathout}/${file}_${expid}_fc${memb}_${yeari}0101_${yeari}0101_$((year0-1))1231.nc ${file}_${expid}_fc${memb}_${yeari}0101_${year0}0101_${yearf}1231.nc ${file}_${expid}_fc${memb}_${yeari}0101_${yeari}0101_${yearf}1231.nc 
      fi
      cp ${file}_${expid}_fc${memb}_${yeari}0101_${yeari}0101_${yearf}1231.nc ${pathout}/.
      rm -f ${pathout}/${file}_${expid}_fc${memb}_${yeari}0101_${yeari}0101_$((year0-1))1231.nc
    done
  done
done
rm -rf $WORKDIR
